// Packet client test applet

import netscape.application.*;
import netscape.util.*;
import netscape.constructor.*;

import java.net.*;

import com.micronova.util.Packet;
import com.micronova.util.HTTPPacketListener;

public class Client extends Application implements Target
{
    TextField textFieldInput;
    TextField textFieldOutput;
    ContainerView container;

    String cgi;

    Thread threadListener;
    HTTPPacketListener listener;

    public void init()
    {
        cgi = parameterNamed("CGI");

        try
        {
            Plan plan = new Plan(codeBase() + "Client.planb");

            plan.unarchiveObjects(this);

            container = (ContainerView)plan.componentNamed("CONTAINER");

            textFieldInput = (TextField)plan.componentNamed("INPUT");
            textFieldOutput = (TextField)plan.componentNamed("OUTPUT");

            Rect bounds = mainRootView().bounds();

            container.moveTo(0, 0);
            container.sizeTo(bounds.width, bounds.height);

            mainRootView().addSubview(container);
            
            plan.releaseObjects();
        }
        catch (Exception e)
        {
            System.err.println("exception:" + e.getMessage());
        }
    }

    public void performCommand(String command, Object object)
    {
        if (command.equals("GO"))
        {
            if ((threadListener != null) && (threadListener.isAlive()))
            {
                try
                {
                    listener.abort();
                    threadListener.join();
                }
                catch (Exception e)
                {
                }
            }

            try
            {
                String input = textFieldInput.stringValue();

                Vector v = new Vector();

                v.addElement(input);

                String cgiurl = codeBase() + cgi;

                listener = new HTTPPacketListener(new URL(cgiurl), v, this, this);
                threadListener = new Thread(listener);

                threadListener.start();
            }
            catch (Exception e)
            {
                System.err.println("exception:" + e.getMessage());
            }
        }
        else if (command.equals(HTTPPacketListener.DATA))
        {
            Vector v = (Vector)object;

            textFieldOutput.setStringValue((String)v.elementAt(0));
        }
        else if (command.equals(HTTPPacketListener.EXCEPTION))
        {
            Exception e = (Exception) object;

            if (e instanceof java.io.EOFException)
            {
                textFieldOutput.setStringValue("Done");
            }
        }
        else
        {
            System.out.println(command + ":" + object);
        }
    }
}


